package com.hzya.frame.plugin.grp.service.impl;

import cn.hutool.core.lang.Assert;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.grpU8.nxproof.oerdjml.entity.OerDjmlEntity;
import com.hzya.frame.grpU8.nxproof.oerdjml.service.IOerDjmlExtService;
import com.hzya.frame.grpU8.nxproof.oerdjml.service.IOerDjmlService;
import com.hzya.frame.plugin.grp.service.IExpensePluginService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

/**
 * @Description grp报销单
 * @Author xiangerlin
 * @Date 2025/3/7 15:39
 **/
public class ExpensePluginServiceImpl implements IExpensePluginService {

    @Autowired
    private IOerDjmlExtService oerDjmlExtService;
    @Autowired
    private IOerDjmlService oerDjmlService;
    @Value("${zt.url}")
    private String interfaceUrl;
    Logger logger = LoggerFactory.getLogger(IExpensePluginService.class);
    /**
     * 执行插件
     *
     * @param json
     * @return
     */
    @Override
    public JsonResultEntity execute(JSONObject json)throws Exception {
        String headersStr = json.getString("headers");//请求头
        String formAppId = json.getString("formAppId");
        String eventType = json.getString("eventType");
        String dataSouceCode = json.getString("apiDataSourceCode");
        Assert.notEmpty(formAppId,"formAppId不能为空");
        Assert.notEmpty(eventType,"eventType不能为空");
        Assert.notEmpty(headersStr,"headers不能为空");
        Assert.notEmpty(dataSouceCode,"数据源编码不能为空");
        logger.info("准备开始组装参数");
        String param = oerDjmlExtService.saveExpensePrePlugin(json);
        logger.info("OA单据组装好准备保存GRP的参数:{}",param);
        String result = HttpRequest.post(interfaceUrl)
                .header("appId","800042")// grp应用
                .header("apiCode","8000420043")//报销单接口
                .header("publicKey","ZJYAcDv1SMgN1oUwzfpV5byfUaN78sVw+L+DB9XTT30aS8hCe7eDIk+3zDUT+v578prj")//OA应用key
                .header("secretKey","ZLQWG13Z30FoeuCgi6/Uc41XF6oLO63550OAa6ggXUmtOZj5MgQNZMjVgL/M4BRkj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")//OA应用密钥
                .body(param).execute().body();
       // JsonResultEntity resultEntity = (JsonResultEntity) oerDjmlService.handleOerDjml(paramJSON);
        // logger.info("保存GRPU8响应参数:{}",JSONObject.toJSON(resultEntity));
        logger.info("保存GRPU8响应参数:{}",result);
        return BaseResult.getSuccessMessageEntity(result);
    }
}
