package com.hzya.frame.grpU8.nxproof.oerdjml.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.grpU8.nxproof.oerdjjsfs.entity.OerDjjsfsEntity;
import com.hzya.frame.grpU8.nxproof.oerdjml.dto.FileInfoDTO;
import com.hzya.frame.grpU8.nxproof.oerdjml.entity.GrpU8CollAttachmentResDTO;
import com.hzya.frame.grpU8.nxproof.oerdjml.entity.OerDjmlEntity;
import com.hzya.frame.grpU8.nxproof.oerdjml.entity.RestUtil;
import com.hzya.frame.grpU8.nxproof.oerdjml.enums.ColEventTypeEnum;
import com.hzya.frame.grpU8.nxproof.oerdjml.service.IOerDjmlExtService;
import com.hzya.frame.grpU8.nxproof.oerdjml.util.OerDjmlUtil;
import com.hzya.frame.grpU8.nxproof.oerdjnr.entity.OerDjnrEntity;
import com.hzya.frame.grpU8.nxproof.oeryszb.entity.OerYszbEntity;
import com.hzya.frame.sysnew.application.database.entity.SysApplicationDatabaseEntity;
import com.hzya.frame.sysnew.application.database.service.ISysApplicationDatabaseService;
import com.hzya.frame.sysnew.application.entity.SysApplicationEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.*;
import java.math.BigDecimal;
import java.net.URLDecoder;
import java.nio.charset.Charset;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * @Description 扩展类，api接口上配置的扩展方法
 * @Author xiangerlin
 * @Date 2024/8/16 13:45
 **/
@Service(value = "oerDjmlExtServiceImpl")
public class OerDjmlExtServiceImpl implements IOerDjmlExtService {

    Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private RestUtil restUtil;
    @Value("${savefile.path:}")
    public String DSK;
    @Autowired
    private ISysApplicationDatabaseService sysApplicationDatabaseService;
    /**
     * 保存方法前，先调这个方法 组装参数
     *
     * @param entity
     * @return
     */
    @Override
    public SysExtensionApiEntity saveExpensePre(SysExtensionApiEntity entity) {
        try {
            String bodys = entity.getBodys();
            String grpDataSourceCode = "";
            SysApplicationEntity receiveApp = entity.getReceiveApp();
            if (null != receiveApp){
                SysApplicationDatabaseEntity sysDatabaseEntity = new SysApplicationDatabaseEntity();
                sysDatabaseEntity.setAppId(receiveApp.getId());
                List<SysApplicationDatabaseEntity> dataBaseList = sysApplicationDatabaseService.query(sysDatabaseEntity);
                if (CollectionUtils.isNotEmpty(dataBaseList)){
                    grpDataSourceCode = dataBaseList.get(0).getSourceCode();
                }
            }
            Map<String, String> headers = entity.getHeaders();
            JSONObject bodyObj =  JSONObject.parseObject(bodys);
            String res = oerValuOf(bodyObj, headers, grpDataSourceCode);
            logger.info("oerValuOf接收到return");
//            String formmainTableName = headers.get("formmainTableName");
//            String forsonTableName = headers.get("forsonTableName");
//            String djlx = headers.get("djlx");
//            //事件类型
//            String eventType = bodyObj.getString("eventType");
//            //summaryId
//            String summaryId = bodyObj.getString("summaryId");
//            JSONObject seeyonData = bodyObj.getJSONObject("businessDataStr");
//            if (null != seeyonData){
//                /**
//                 * 流程发起 保存/更新单据 要全部数据
//                 * 流程撤销 只更新状态，传单号和状态就好了
//                 * 流程终止 只更新状态，传单号和状态就好了
//                 * 流程结束 更新状态 并上传附件
//                 */
//                JSONObject formmainData = seeyonData.getJSONObject(formmainTableName);
//                JSONArray forsonData = seeyonData.getJSONArray(forsonTableName);
//                String res = "";
//                if (DjlxEnum.TRAVEL.type.equals(djlx)) {
//                    //差旅报销 travel
//                    res = travel(headers,eventType,summaryId,grpDataSourceCode,formmainData,forsonData);
//                }else if(DjlxEnum.EXPENSE.type.equals(djlx)){
//                    //费用报销 expense
//                    res = expense(headers,eventType,summaryId,grpDataSourceCode, formmainData, forsonData);
//                }else if (DjlxEnum.LABOR.type.equals(djlx)){
//                    //劳务费 labor
//                }
//                if (StrUtil.isNotEmpty(res)){
//                    entity.setBodys(res);
//                    return entity;
//                }
//            }
            if (StrUtil.isNotEmpty(res)){
                logger.info("参数准备设置到entity.bodys里");
                entity.setBodys(res);
                logger.info("设置到entity.bodys里完成，准备return");
                return entity;
            }
        }catch (Exception ex ){
            logger.error("保存报销单之前组装参数出错",ex);
        }
        return null;
    }

    /**
     * 保存方法前，先调这个方法 组装参数
     * 插件方式执行用这个方法
     *
     * @param jsonObject
     * @return
     */
    @Override
    public String saveExpensePrePlugin(JSONObject jsonObject) {
        if (null != jsonObject){
            logger.info("进入保存去方法:{}",jsonObject.toString());
            JSONObject jsonStr = jsonObject.getJSONObject("jsonStr");
            JSONObject bodyObj = jsonStr.getJSONObject("businessDataStr");
            Map<String, String> headers = JSON.parseObject(jsonObject.getString("headers"), new HashMap<String, String>().getClass());
            String dataSourceCode = jsonObject.getString("apiDataSourceCode");
            String res = oerValuOf(jsonStr, headers, dataSourceCode);
            logger.info("保存前方法返回值:{}",res);
            return res;
        }
        return null;
    }

    /**
     * 组装参数
     * @param jsonStr 请求体参数
     * @param headers 请求头参数
     * @param dataSourceCode 数据源编码
     * @return
     */
    private String oerValuOf(JSONObject jsonStr,Map<String, String> headers,String dataSourceCode){
        if (null != jsonStr && null != headers && !headers.isEmpty()){
            String formmainTableName = headers.get("formmainTableName");
            String forsonTableName = headers.get("forsonTableName");
            String forsonTableName1 = headers.get("forsonTableName1");
            String forsonTableName2 = headers.get("forsonTableName2");
            String djlx = headers.get("djlx");
            //事件类型
            String eventType = jsonStr.getString("eventType");
            //summaryId
            String summaryId = jsonStr.getString("summaryId");
            JSONObject seeyonData = jsonStr.getJSONObject("businessDataStr");
            if (null != seeyonData){
                /**
                 * 流程发起 保存/更新单据 要全部数据
                 * 流程撤销 只更新状态，传单号和状态就好了
                 * 流程终止 只更新状态，传单号和状态就好了
                 * 流程结束 更新状态 并上传附件
                 */
                JSONObject formmainData = seeyonData.getJSONObject(formmainTableName);
                JSONArray forsonData = seeyonData.getJSONArray(forsonTableName);
                //劳保费用
                JSONArray forson0045Data = seeyonData.getJSONArray(forsonTableName1);
                JSONArray forson0046Data = seeyonData.getJSONArray(forsonTableName2);
                String res = "";
                if (DjlxEnum.TRAVEL.type.equals(djlx)) {
                    logger.info("准备组装差旅报销单参数");
                    //差旅报销 travel
                    res = travel(headers,eventType,summaryId,dataSourceCode,formmainData,forsonData);
                }else if(DjlxEnum.EXPENSE.type.equals(djlx)){
                    logger.info("准备组装费用报销单参数");
                    //费用报销 expense
                    res = expense(headers,eventType,summaryId,dataSourceCode, formmainData, forsonData);
                    logger.info("oerValuOf方法已经组装好参数，准备return");
                }else if (DjlxEnum.LABOR.type.equals(djlx)){
                    //判断一下要用哪个明细表
                    res = labor(headers,eventType,summaryId,dataSourceCode,formmainData,forsonData,forson0045Data,forson0046Data);
                }else if (DjlxEnum.HXKY.type.equals(djlx)){
                    //横向科研
                    res = hxky(headers,eventType,summaryId,dataSourceCode, formmainData, forsonData);
                }else if (DjlxEnum.ZXKY.type.equals(djlx)){
                    //纵向科研
                    res = zxky(headers,eventType,summaryId,dataSourceCode, formmainData, forsonData);
                }
                logger.info("oerValuOf方法return");
                return res;
            }
        }
        return null;
    }
    /**
     * 费用报销单
     * @param headers 请求头
     * @param eventType 事件类型
     * @param summaryId 流程id
     * @param dataSourceCode
     * @param formmainData 主表数据
     * @param forsonData 子表数据
     */
    private String expense(Map<String, String> headers, String eventType,String summaryId, String dataSourceCode,JSONObject formmainData, JSONArray forsonData) {
        String djlxid = headers.get("djlxid");
        String flowcode = headers.get("flowcode");
        String fileApiCode = headers.get("file_api_code");
        OerDjmlEntity djml = new OerDjmlEntity();
        djml.setLclb(eventType);
        djml.setDjbh(formmainData.getString("field0001"));
        djml.setDjlxId(djlxid);
        djml.setDataSourceCode(dataSourceCode);
        JSONObject forsonData0 = forsonData.getJSONObject(0);
        //流程发起
        if (ColEventTypeEnum.ONSTART.getType().equals(eventType)){
            djml.setGsdm(forsonData0.getString("field0026"));
            djml.setKjnd(forsonData0.getString("field0027"));
            djml.setZt("2");
            djml.setCrerdm(formmainData.getString("field0037"));//制单人代码
            djml.setCrermc(formmainData.getString("field0038"));//制单人名称
            djml.setCrerdate(timestampConvert(formmainData.getString("start_date"),"yyyyMMdd"));//创建时间
            djml.setDjdate(timestampConvert(formmainData.getString("field0039"),"yyyyMMdd"));//单据日期
            djml.setJe(formmainData.getString("field0016"));//金额
            djml.setJedx(formmainData.getString("field0018"));//金额大写
            djml.setYjje("0.00");
            djml.setThje("0.00");
            djml.setBlje(formmainData.getString("field0016"));
            djml.setFjs(formmainData.getString("field0022"));//附件数
            djml.setZy(formmainData.getString("field0023"));//摘要
            djml.setBmdm(formmainData.getString("field0052"));//经费使用部门代码
            djml.setBmmc(formmainData.getString("field0051"));//经费使用部门名称
            djml.setXmdm(formmainData.getString(""));//项目代码
            djml.setXmmc(formmainData.getString(""));//项目名称
            djml.setGrdm(formmainData.getString("field0050"));//报销人代码
            djml.setGrmc(formmainData.getString("field0049"));//报销人名称
            djml.setJjdm("");//经济代码
            djml.setJjmc("");//经济名称
            djml.setYhzh(forsonData0.getString("field0015"));
            djml.setKhyh(forsonData0.getString("field0014"));
            djml.setCurshjd("-9");
            djml.setNextshjd("999");
            djml.setFlowcode(flowcode);
            djml.setJsfs(OerDjmlUtil.spliceStr(forsonData0.getString("field0042"),forsonData0.getString("field0043")));//结算方式
            djml.setTel("");//电话
            djml.setSsrq(DateUtil.format(formmainData.getDate("field0039"),"yyyyMMddHHmmssSSS"));//送审日期
            djml.setSsrid(formmainData.getString("field0037"));//送审人id
            djml.setSsr(formmainData.getString("field0038"));//送审人
            //报销明细
            List<OerDjnrEntity> djnrList = new ArrayList<>();
            //结算方式
            List<OerDjjsfsEntity> jsfsList = new ArrayList<>();
            //预算指标
            List<OerYszbEntity> yszbList = new ArrayList<>();
            int xh = 1;
            for (int i = 0; i< forsonData.size(); i++) {
                JSONObject forson = forsonData.getJSONObject(i);
                String gsdm = forson.getString("field0026");
                String kjnd = forson.getString("field0027");
                String je = forson.getString("field0007");
                //单据内容
                OerDjnrEntity djnr = new OerDjnrEntity();
                djnr.setXh(String.valueOf(xh));
                djnr.setGsdm(gsdm);
                djnr.setKjnd(kjnd);
                djnr.setDjlxId(djlxid);
                djnr.setBnxId(headers.get("bxmx_bnxid"));
                djnr.setJe(je);
                djnr.setBmdm(forson.getString("field0034"));//经费所在部门代码
                djnr.setBmmc(forson.getString("field0010"));//经费所在部门名称
                djnr.setXmdm(forson.getString("field0004"));
                djnr.setXmmc(forson.getString("field0005"));
                djnr.setJjdm("");
                djnr.setJjmc("");
                djnr.setFzx8dm("");
                djnr.setFzx8mc("");
                djnr.setZbId(forson.getString("field0003"));
                djnr.setJflxdm("");
                djnr.setJflxmc("");
                djnr.setZy(forson.getString("field0017"));
                djnr.setFjs(djml.getFjs());
                djnrList.add(djnr);
                //结算方式
                OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
                jsfs.setGsdm(gsdm);
                jsfs.setKjnd(kjnd);
                jsfs.setDjlxId(djlxid);
                jsfs.setBnxid(headers.get("jsfs_bnxid"));
                jsfs.setXh(String.valueOf(xh));
                jsfs.setJsfsdm(forson.getString("field0043"));
                jsfs.setJsfsmc(forson.getString("field0042"));
                jsfs.setKmdm("");
                jsfs.setKmmc("");
                jsfs.setSkr(forson.getString("field0013"));
                jsfs.setKhyh(forson.getString("field0014"));
                jsfs.setYhzh(forson.getString("field0015"));
                jsfs.setJe(je);
                jsfs.setYh("");
                jsfs.setYhhh("");
                jsfs.setProvince("");
                jsfs.setCity("");
                jsfs.setRytype("");
                jsfs.setYt(forson.getString("field0079"));
                jsfsList.add(jsfs);
                //预算指标
                OerYszbEntity yszb = new OerYszbEntity();
                BeanUtil.copyProperties(djnr,yszb);
                yszb.setBnxId(headers.get("yszb_bnxid"));
                yszb.setZbdm("");
                yszb.setZy(forson.getString("field0079"));
                yszb.setKmdm("");
                yszb.setKmmc("");
                yszb.setXh(String.valueOf(xh));
                yszbList.add(yszb);
                xh++;
            }
            logger.info("报销单主表:{}",JSONObject.toJSONString(djml));
            logger.info("报销单明细表:{}",JSONObject.toJSONString(djnrList));
            logger.info("报销单结算方式:{}",JSONObject.toJSONString(jsfsList));
            logger.info("报销单预算指标:{}",JSONObject.toJSONString(yszbList));
            djml.setOerDjnrEntityList(djnrList);
            djml.setOerDjjsfsEntityList(jsfsList);
            djml.setOerYszbEntityList(yszbList);
        }else if (ColEventTypeEnum.ONSTOP.getType().equals(eventType)){
        //流程终止 修改状态，释放指标
        djml.setZt("0");
        djml.setCurshjd("0");
        djml.setNextshjd("-9");
        djml.setSsrid(null);
        djml.setSsr(null);
        djml.setSsrq(null);
        djml.setShrId(null);
        djml.setShrq(null);
    }else if (ColEventTypeEnum.ONCANCEL.getType().equals(eventType)){
        //流程撤销 修改状态，释放指标
        djml.setZt("1");
        djml.setCurshjd("0");
        djml.setNextshjd("-9");
        djml.setSsrid(null);
        djml.setSsr(null);
        djml.setSsrq(null);
        djml.setShrId(null);
        djml.setShrq(null);
    }else if (ColEventTypeEnum.ONPROCESSFINISHED.getType().equals(eventType)){
        //流程结束事件
        djml.setZt("3");
        djml.setCurshjd("999");
        djml.setNextshjd("-1");
        djml.setCrerdm(formmainData.getString("field0037"));//制单人代码
        djml.setCrermc(formmainData.getString("field0038"));//制单人名称
        //查询协同附件
        List<FileInfoDTO> fileInfoList = fileDownloadV1(summaryId, fileApiCode);
        djml.setFileInfoList(fileInfoList);
    }
        String djmlStr = JSONObject.toJSONString(djml);
        logger.info("费用报销单报文:{}",djmlStr);
        return djmlStr;
    }

    /**
     * 差旅报销单
     * @param headers 请求头
     * @param eventType 事件类型
     * @param summaryId 流程id
     * @param dataSourceCode
     * @param formmainData 主表数据
     * @param forsonData 子表数据
     */
    private String travel(Map<String, String> headers, String eventType,String summaryId, String dataSourceCode,JSONObject formmainData, JSONArray forsonData) {
        String djlxid = headers.get("djlxid");
        String flowcode = headers.get("flowcode");
        String fileApiCode = headers.get("file_api_code");
        OerDjmlEntity djml = new OerDjmlEntity();
        djml.setLclb(eventType);
        djml.setDjbh(formmainData.getString("field0001"));
        djml.setDataSourceCode(dataSourceCode);
        //流程发起
        if (ColEventTypeEnum.ONSTART.getType().equals(eventType)){
            JSONObject forjsonData0 = forsonData.getJSONObject(0);
            djml.setGsdm(forjsonData0.getString("field0178"));
            djml.setKjnd(forjsonData0.getString("field0180"));
            djml.setDjlxId(djlxid);
            djml.setZt("2");
            djml.setCrerdm(formmainData.getString("field0171"));//制单人代码
            djml.setCrermc(formmainData.getString("field0172"));//制单人名称
            djml.setCrerdate(timestampConvert(formmainData.getString("start_date"),"yyyyMMdd"));
            djml.setDjdate((timestampConvert(formmainData.getString("field0004"),"yyyyMMdd")));
            djml.setJe(formmainData.getString("field0161"));//金额
            djml.setJedx(formmainData.getString("field0105"));//金额大写
            djml.setYjje("0.00");
            djml.setThje("0.00");
            djml.setBlje(formmainData.getString(""));//补领金额
            djml.setFjs( formmainData.getString("field0122"));//附件数
            djml.setZy( formmainData.getString("field0013"));//摘要
            //部门代码
            djml.setBmdm(formmainData.getString("field0169"));//经费使用部门代码
            djml.setBmmc(formmainData.getString("field0170"));//经费使用部门名称
            //项目代码
            djml.setXmdm(forjsonData0.getString("field0128"));
            djml.setXmmc(forjsonData0.getString("field0129"));
            //经办人代码
            djml.setGrdm(formmainData.getString("field0167"));
            djml.setGrmc(formmainData.getString("field0168"));
            //经济代码- 这个用不到，grp没有启用
            djml.setJjdm("");
            djml.setJjmc("");
            //银行帐号 开户银行
            djml.setYhzh(forjsonData0.getString("field0159"));
            djml.setKhyh(forjsonData0.getString("field0158"));
            //当前审核节点、下个审核节点 ,不在grp审批，是不是不用填了
            djml.setCurshjd("-9");
            djml.setNextshjd("999");
            djml.setFlowcode(flowcode);
            djml.setJsfs(OerDjmlUtil.spliceStr(forjsonData0.getString("field0182"), forjsonData0.getString("field0156")));
            //电话
            djml.setTel(formmainData.getString("field0121"));
            //出差人
            djml.setClf_ccr(formmainData.getString("field0190"));
            //送审日期
            djml.setSsrq( DateUtil.format(formmainData.getDate("startDate"),"yyyyMMddHHmmssSSS"));
            djml.setSsrid(formmainData.getString("field0171"));
            djml.setSsr(formmainData.getString("field0172"));
            djml.setClf_cclb(forjsonData0.getString("field0130"));
            //报销明细
            List<OerDjnrEntity> djnrList = new ArrayList<>();
            //结算方式
            List<OerDjjsfsEntity> jsfsList = new ArrayList<>();
            //预算指标
            List<OerYszbEntity> yszbList = new ArrayList<>();
            int xh = 1;
            for (int i = 0; i< forsonData.size(); i++) {
                JSONObject forson = forsonData.getJSONObject(i);
                String gsdm = forson.getString("field0178");
                String kjnd = forson.getString("field0180");
                String je = forson.getString("field0155");
                //单据内容
                OerDjnrEntity djnr = new OerDjnrEntity();
                djnr.setXh(String.valueOf(xh));
                djnr.setGsdm(gsdm);
                djnr.setKjnd(kjnd);
                djnr.setDjlxId(djlxid);
                djnr.setBnxId(headers.get("bxmx_bnxid"));
                djnr.setJe(je);
                djnr.setBmdm(forson.getString("field0184"));
                djnr.setBmmc(forson.getString("field0185"));
                djnr.setXmdm(forson.getString("field0128"));
                djnr.setXmmc(forson.getString("field0129"));
                djnr.setJjdm("");
                djnr.setJjmc("");
                //没用到，模板上没配置这个字段
                djnr.setFzx8dm("");
                djnr.setFzx8mc("");
                //指标id
                djnr.setZbId(forson.getString("field0126"));
                //模板上没有
                djnr.setJflxdm("");
                djnr.setJflxmc("");
                djnr.setZy(forson.getString("field0160"));
                djnr.setClf_startdate(timestampConvert(forson.getString("field0134"),"yyyy-MM-dd"));
                djnr.setClf_enddate(timestampConvert(forson.getString("field0135"),"yyyy-MM-dd"));
                djnr.setClf_ccdd(forson.getString("field0137"));
                djnr.setClf_ccksd(forson.getString("field0136"));
                djnr.setClf_djzs(djml.getFjs());
                djnr.setClf_ccts(forson.getString("field0141"));
                djnr.setClf_cctsbz(forson.getString("field0199"));//补助天数
                djnr.setClf_ccrs(forson.getString("field0140"));
                djnr.setClf_zw(forson.getString("field0138"));//职务
                djnr.setClf_jtgj(forson.getString("field0191"));//交通工具
                //住宿费
                djnr.setClf_zsbz(forson.getString("field0143"));
                djnr.setClf_zsf(forson.getString("field0144"));
                //伙食补助
                djnr.setClf_hsbz(forson.getString("field0145"));
                djnr.setClf_hsf(forson.getString("field0146"));
                //交通补助
                djnr.setClf_jtbz(forson.getString("field0147"));//交通补助标准
                //交通补助实报=公杂费+交通补助实报  2025年6月4日群里开户在线演示时提出的
                BigDecimal gzf = Convert.toBigDecimal(forson.getString("field0150"), BigDecimal.ZERO);
                BigDecimal jtbz = Convert.toBigDecimal(forson.getString("field0192"), BigDecimal.ZERO);
                BigDecimal total = gzf.add(jtbz);
                djnr.setClf_jtbzf(String.valueOf(total));//交通补助实报
                djnr.setClf_jtf(forson.getString("field0148"));
                //其他
                djnr.setClf_qtf(forson.getString("field0151"));
                //公杂

                djnr.setFjs(djml.getFjs());
                djnrList.add(djnr);
                //结算方式
                OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
                jsfs.setGsdm(gsdm);
                jsfs.setKjnd(kjnd);
                jsfs.setDjlxId(djlxid);
                jsfs.setBnxid(headers.get("jsfs_bnxid"));
                jsfs.setXh(String.valueOf(xh));
                jsfs.setJsfsdm(forson.getString("field0182"));
                jsfs.setJsfsmc(forson.getString("field0156"));
                jsfs.setKmdm(forson.getString(""));
                jsfs.setKmmc(forson.getString(""));
                jsfs.setSkr(forson.getString("field0157"));
                jsfs.setKhyh(forson.getString("field0158"));
                jsfs.setYhzh(forson.getString("field0159"));
                jsfs.setJe(je);
                jsfs.setYh("");//银行类型 例如 招商银行
                jsfs.setYhhh("");// 联行号
                jsfs.setProvince("");//省
                jsfs.setCity("");//市
                //支付方式为个人、公务卡时 可以选择 经办人、负责人、其他
                jsfs.setRytype("");//人员类型
                //用途
                jsfs.setYt(forson.getString("field0160"));
                jsfsList.add(jsfs);
                //预算指标
                OerYszbEntity yszb = new OerYszbEntity();
                BeanUtil.copyProperties(djnr,yszb);
                yszb.setBnxId(headers.get("yszb_bnxid"));
                yszb.setZbdm(forson.getString("field0181"));
                yszb.setZy(forson.getString("field0125"));
                yszb.setKmdm(forson.getString(""));
                yszb.setKmmc(forson.getString(""));
                yszb.setXh(String.valueOf(xh));
                yszbList.add(yszb);
                xh++;
            }
            logger.info("报销单主表:{}",JSONObject.toJSONString(djml));
            logger.info("报销单明细表:{}",JSONObject.toJSONString(djnrList));
            logger.info("报销单结算方式:{}",JSONObject.toJSONString(jsfsList));
            logger.info("报销单预算指标:{}",JSONObject.toJSONString(yszbList));
            djml.setOerDjnrEntityList(djnrList);
            djml.setOerDjjsfsEntityList(jsfsList);
            djml.setOerYszbEntityList(yszbList);
        }else if (ColEventTypeEnum.ONSTOP.getType().equals(eventType)){
            //流程终止 修改状态，释放指标
            djml.setZt("0");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONCANCEL.getType().equals(eventType)){
            //流程撤销 修改状态，释放指标
            djml.setZt("1");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONPROCESSFINISHED.getType().equals(eventType)){
            //流程结束事件
            djml.setZt("3");
            djml.setCurshjd("999");
            djml.setNextshjd("-1");
            //查询协同附件
            List<FileInfoDTO> fileInfoList = fileDownloadV1(summaryId, fileApiCode);
            djml.setFileInfoList(fileInfoList);
        }
        String djmlStr = JSONObject.toJSONString(djml);
        logger.info("差旅报销单报文：{}",djmlStr);
        return djmlStr;
    }
    //横向科研
    private String hxky(Map<String, String> headers, String eventType, String summaryId, String dataSourceCode, JSONObject formmainData, JSONArray forsonData) {
        String djlxid = headers.get("djlxid");
        String flowcode = headers.get("flowcode");
        String fileApiCode = headers.get("file_api_code");
        OerDjmlEntity djml = new OerDjmlEntity();
        djml.setLclb(eventType);
        djml.setDjbh(formmainData.getString("field0001"));
        djml.setDjlxId(djlxid);
        djml.setDataSourceCode(dataSourceCode);
        JSONObject forsonData0 = forsonData.getJSONObject(0);
        if (ColEventTypeEnum.ONSTART.getType().equals(eventType)){
            JSONObject forjsonData0 = forsonData.getJSONObject(0);
            djml.setGsdm(formmainData.getString("field0037"));
            djml.setKjnd(formmainData.getString("field0038"));
            djml.setDjlxId(djlxid);
            djml.setZt("2");
            djml.setCrerdm(formmainData.getString("field0039"));//制单人代码
            djml.setCrermc(formmainData.getString("field0045"));//制单人名称
            djml.setCrerdate(timestampConvert(formmainData.getString("start_date"),"yyyyMMdd"));
            djml.setDjdate((timestampConvert(formmainData.getString("field0029"),"yyyyMMdd")));
            djml.setJe(formmainData.getString("field0011"));//金额
            djml.setJedx(formmainData.getString("field0049"));//金额大写
            djml.setGrdm(formmainData.getString("field0042"));//报销人代码
            djml.setGrmc(formmainData.getString("field0041"));//报销人名称
            djml.setBmdm(formmainData.getString("field0044"));//部门代码
            djml.setBmmc(formmainData.getString("field0046"));//部门名称
            djml.setXmdm(formmainData.getString("field0052"));//项目代码
            djml.setXmmc(formmainData.getString("field0002"));//项目名称
            djml.setFjs(formmainData.getString("field0048"));//附件数
            djml.setZy(formmainData.getString("field0047"));//事由
            djml.setSfzh(forsonData0.getString("field0021"));//身份证号
            djml.setTel(forsonData0.getString("field0022"));//电话
            djml.setWX00000051(formmainData.getString("field0057"));//申请类型
            djml.setWX00000054(formmainData.getString("field0004"));//资助经费总额
            djml.setWX00000055(formmainData.getString("field0018"));//已到位经费
            djml.setWX00000056(formmainData.getString("field0007"));//激励费总额
            djml.setWX00000057(formmainData.getString("field0008"));//已支出激励费
            djml.setCurshjd("-9");
            djml.setNextshjd("999");
            djml.setFlowcode(flowcode);
            //报销明细
            List<OerDjnrEntity> djnrList = new ArrayList<>();
            //结算方式
            List<OerDjjsfsEntity> jsfsList = new ArrayList<>();
            //预算指标
            List<OerYszbEntity> yszbList = new ArrayList<>();
            int xh = 1;
            for (int i = 0; i< forsonData.size(); i++) {
                JSONObject forson = forsonData.getJSONObject(i);
                String gsdm = djml.getGsdm();
                String kjnd = djml.getKjnd();
                String je = forson.getString("field0024");
                //单据内容
                OerDjnrEntity djnr = new OerDjnrEntity();
                djnr.setXh(String.valueOf(xh));
                djnr.setGsdm(gsdm);
                djnr.setKjnd(kjnd);
                djnr.setDjlxId(djlxid);
                djnr.setBnxId(headers.get("bxmx_bnxid"));
                djnr.setJe(je);
                djnr.setBmdm(formmainData.getString("field0051"));
                djnr.setBmmc(formmainData.getString("field0050"));
                djnr.setXmdm(djml.getXmdm());
                djnr.setXmmc(djml.getXmmc());
                //指标id
                djnr.setZbId(formmainData.getString("field0030"));
                djnr.setZy(djml.getZy());
                djnr.setFjs(djml.getFjs());
                //支出项目
                djnr.setFzx6dm(formmainData.getString("field0053"));
                djnr.setFzx6mc(formmainData.getString("field0054"));
                //资金来源
                djnr.setFzx7dm(formmainData.getString("field0051"));
                djnr.setFzx7mc(formmainData.getString("field0056"));
                djnrList.add(djnr);
                //结算方式
                OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
                jsfs.setGsdm(gsdm);
                jsfs.setKjnd(kjnd);
                jsfs.setDjlxId(djlxid);
                jsfs.setBnxid(headers.get("jsfs_bnxid"));
                jsfs.setXh(String.valueOf(xh));
                jsfs.setJsfsdm(forson.getString("field0061"));
                jsfs.setJsfsmc(forson.getString("field0060"));
                jsfs.setKmdm(forson.getString(""));
                jsfs.setKmmc(forson.getString(""));
                jsfs.setSkr(forson.getString("field0020"));
                jsfs.setKhyh(forson.getString("field0036"));
                jsfs.setYhzh(forson.getString("field0023"));
                jsfs.setJe(je);
                jsfs.setYh("");//银行类型 例如 招商银行
                jsfs.setYhhh("");// 联行号
                jsfs.setProvince("");//省
                jsfs.setCity("");//市
                //支付方式为个人、公务卡时 可以选择 经办人、负责人、其他
                jsfs.setRytype("");//人员类型
                //用途
                jsfs.setYt(forson.getString(""));
                jsfsList.add(jsfs);
                //预算指标
                OerYszbEntity yszb = new OerYszbEntity();
                BeanUtil.copyProperties(djnr,yszb);
                yszb.setBnxId(headers.get("yszb_bnxid"));
                yszb.setZbdm(forson.getString("field0030"));
                yszb.setZy(djnr.getZy());
                yszb.setKmdm(forson.getString(""));
                yszb.setKmmc(forson.getString(""));
                yszb.setXh(String.valueOf(xh));
                yszbList.add(yszb);
                xh++;
            }
            logger.info("横向科研主表:{}",JSONObject.toJSONString(djml));
            logger.info("横向科研明细表:{}",JSONObject.toJSONString(djnrList));
            logger.info("横向科研结算方式:{}",JSONObject.toJSONString(jsfsList));
            logger.info("横向科研预算指标:{}",JSONObject.toJSONString(yszbList));
            djml.setOerDjnrEntityList(djnrList);
            djml.setOerDjjsfsEntityList(jsfsList);
            djml.setOerYszbEntityList(yszbList);
        }else if (ColEventTypeEnum.ONSTOP.getType().equals(eventType)){
            //流程终止 修改状态，释放指标
            djml.setZt("0");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONCANCEL.getType().equals(eventType)){
            //流程撤销 修改状态，释放指标
            djml.setZt("1");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONPROCESSFINISHED.getType().equals(eventType)){
            //流程结束事件
            djml.setZt("3");
            djml.setCurshjd("999");
            djml.setNextshjd("-1");
            //查询协同附件
            List<FileInfoDTO> fileInfoList = fileDownloadV1(summaryId, fileApiCode);
            djml.setFileInfoList(fileInfoList);
        }
        String djmlStr = JSONObject.toJSONString(djml);
        logger.info("横向科研报文：{}",djmlStr);
        return djmlStr;
    }

    //纵向科研
    private String zxky(Map<String, String> headers, String eventType, String summaryId, String dataSourceCode, JSONObject formmainData, JSONArray forsonData) {
        String djlxid = headers.get("djlxid");
        String flowcode = headers.get("flowcode");
        String fileApiCode = headers.get("file_api_code");
        OerDjmlEntity djml = new OerDjmlEntity();
        djml.setLclb(eventType);
        djml.setDjbh(formmainData.getString("field0001"));
        djml.setDjlxId(djlxid);
        djml.setDataSourceCode(dataSourceCode);
        JSONObject forsonData0 = forsonData.getJSONObject(0);
        if (ColEventTypeEnum.ONSTART.getType().equals(eventType)){
            JSONObject forjsonData0 = forsonData.getJSONObject(0);
            djml.setGsdm(formmainData.getString("field0036"));
            djml.setKjnd(formmainData.getString("field0037"));
            djml.setDjlxId(djlxid);
            djml.setZt("2");
            djml.setCrerdm(formmainData.getString("field0039"));//制单人代码
            djml.setCrermc(formmainData.getString("field0038"));//制单人名称
            djml.setCrerdate(timestampConvert(formmainData.getString("start_date"),"yyyyMMdd"));
            djml.setDjdate((timestampConvert(formmainData.getString("field0031"),"yyyyMMdd")));
            djml.setJe(formmainData.getString("field0011"));//金额
            djml.setJedx(formmainData.getString("field0048"));//金额大写
            djml.setGrdm(formmainData.getString("field0043"));//报销人代码
            djml.setGrmc(formmainData.getString("field0042"));//报销人名称
            djml.setBmdm(formmainData.getString("field0045"));//部门代码
            djml.setBmmc(formmainData.getString("field0040"));//部门名称
            djml.setXmdm(formmainData.getString("field0051"));//项目代码
            djml.setXmmc(formmainData.getString("field0002"));//项目名称
            djml.setFjs(formmainData.getString("field0047"));//附件数
            djml.setZy(formmainData.getString("field0046"));//事由
            djml.setSfzh(forsonData0.getString("field0021"));//身份证号
            djml.setTel(forsonData0.getString("field0022"));//电话
            djml.setWX00000051(formmainData.getString("field0056"));//申请类型
            djml.setWX00000054(formmainData.getString("field0004"));//资助经费总额
            djml.setWX00000055(formmainData.getString("field0018"));//已到位经费
            djml.setWX00000056(formmainData.getString("field0007"));//激励费总额
            djml.setWX00000057(formmainData.getString("field0008"));//已支出激励费
            djml.setCurshjd("-9");
            djml.setNextshjd("999");
            djml.setFlowcode(flowcode);
            //报销明细
            List<OerDjnrEntity> djnrList = new ArrayList<>();
            //结算方式
            List<OerDjjsfsEntity> jsfsList = new ArrayList<>();
            //预算指标
            List<OerYszbEntity> yszbList = new ArrayList<>();
            int xh = 1;
            for (int i = 0; i< forsonData.size(); i++) {
                JSONObject forson = forsonData.getJSONObject(i);
                String gsdm = djml.getGsdm();
                String kjnd = djml.getKjnd();
                String je = forson.getString("field0024");
                //单据内容
                OerDjnrEntity djnr = new OerDjnrEntity();
                djnr.setXh(String.valueOf(xh));
                djnr.setGsdm(gsdm);
                djnr.setKjnd(kjnd);
                djnr.setDjlxId(djlxid);
                djnr.setBnxId(headers.get("bxmx_bnxid"));
                djnr.setJe(je);
                djnr.setBmdm(formmainData.getString("field0049"));
                djnr.setBmmc(formmainData.getString("field0050"));
                djnr.setXmdm(djml.getXmdm());
                djnr.setXmmc(djml.getXmmc());
                //指标id
                djnr.setZbId(formmainData.getString("field0032"));
                djnr.setZy(djml.getZy());
                djnr.setFjs(djml.getFjs());
                //支出项目
                djnr.setFzx6dm(formmainData.getString("field0052"));
                djnr.setFzx6mc(formmainData.getString("field0053"));
                //资金来源
                djnr.setFzx7dm(formmainData.getString("field0054"));
                djnr.setFzx7mc(formmainData.getString("field0055"));
                djnrList.add(djnr);
                //结算方式
                OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
                jsfs.setGsdm(gsdm);
                jsfs.setKjnd(kjnd);
                jsfs.setDjlxId(djlxid);
                jsfs.setBnxid(headers.get("jsfs_bnxid"));
                jsfs.setXh(String.valueOf(xh));
                jsfs.setJsfsdm(forson.getString("field0060"));
                jsfs.setJsfsmc(forson.getString("field0059"));
                jsfs.setKmdm(forson.getString(""));
                jsfs.setKmmc(forson.getString(""));
                jsfs.setSkr(forson.getString("field0020"));
                jsfs.setKhyh(forson.getString("field0028"));
                jsfs.setYhzh(forson.getString("field0023"));
                jsfs.setJe(je);
                jsfs.setYh("");//银行类型 例如 招商银行
                jsfs.setYhhh("");// 联行号
                jsfs.setProvince("");//省
                jsfs.setCity("");//市
                //支付方式为个人、公务卡时 可以选择 经办人、负责人、其他
                jsfs.setRytype("");//人员类型
                //用途
                jsfs.setYt(forson.getString(""));
                jsfsList.add(jsfs);
                //预算指标
                OerYszbEntity yszb = new OerYszbEntity();
                BeanUtil.copyProperties(djnr,yszb);
                yszb.setBnxId(headers.get("yszb_bnxid"));
                yszb.setZbdm(forson.getString("field0032"));
                yszb.setZy(djnr.getZy());
                yszb.setKmdm(forson.getString(""));
                yszb.setKmmc(forson.getString(""));
                yszb.setXh(String.valueOf(xh));
                yszbList.add(yszb);
                xh++;
            }
            logger.info("纵向科研主表:{}",JSONObject.toJSONString(djml));
            logger.info("纵向科研明细表:{}",JSONObject.toJSONString(djnrList));
            logger.info("纵向科研结算方式:{}",JSONObject.toJSONString(jsfsList));
            logger.info("纵向科研预算指标:{}",JSONObject.toJSONString(yszbList));
            djml.setOerDjnrEntityList(djnrList);
            djml.setOerDjjsfsEntityList(jsfsList);
            djml.setOerYszbEntityList(yszbList);
        }else if (ColEventTypeEnum.ONSTOP.getType().equals(eventType)){
            //流程终止 修改状态，释放指标
            djml.setZt("0");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONCANCEL.getType().equals(eventType)){
            //流程撤销 修改状态，释放指标
            djml.setZt("1");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONPROCESSFINISHED.getType().equals(eventType)){
            //流程结束事件
            djml.setZt("3");
            djml.setCurshjd("999");
            djml.setNextshjd("-1");
            //查询协同附件
            List<FileInfoDTO> fileInfoList = fileDownloadV1(summaryId, fileApiCode);
            djml.setFileInfoList(fileInfoList);
        }
        String djmlStr = JSONObject.toJSONString(djml);
        logger.info("纵向科研报文：{}",djmlStr);
        return djmlStr;
    }

    /**
     * 劳务费
     * @param headers 头部参数
     * @param eventType 事件类型
     * @param summaryId 流程id
     * @param dataSourceCode 数据源编码
     * @param formmainData 主表数据
     * @param forson0044Data 子1表数据
     * @param forson0045Data 子表2数据
     * @param forson0046Data 子表3数据
     * @return
     */
    private String labor(Map<String, String> headers, String eventType, String summaryId, String dataSourceCode, JSONObject formmainData, JSONArray forson0044Data, JSONArray forson0045Data, JSONArray forson0046Data) {
        String djlxid = headers.get("djlxid");
        String flowcode = headers.get("flowcode");
        String fileApiCode = headers.get("file_api_code");
        OerDjmlEntity djml = new OerDjmlEntity();
        djml.setLclb(eventType);
        djml.setDjbh(formmainData.getString("field0022"));
        djml.setDjlxId(djlxid);
        djml.setDataSourceCode(dataSourceCode);
        String fflx = formmainData.getString("field0102");
        JSONArray forsonData = null;
        JSONObject forsonData0 = null;
        switch (fflx){
            case "0":
            case "3":
                forsonData0 = forson0044Data.getJSONObject(0);
                forsonData = forson0044Data;
                break;
            case "1":
                forsonData0 = forson0045Data.getJSONObject(0);
                forsonData = forson0045Data;
                break;
            case "2":
                forsonData0 = forson0046Data.getJSONObject(0);
                forsonData = forson0046Data;
                break;
        }
        if (ColEventTypeEnum.ONSTART.getType().equals(eventType)){
            djml.setGsdm(formmainData.getString("field0043"));
            djml.setKjnd(formmainData.getString("field0044"));
            djml.setDjlxId(djlxid);
            djml.setZt("2");
            djml.setFjs("0");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setShrId("-1");
            djml.setCrerdm(formmainData.getString("field0084"));//制单人代码
            djml.setCrermc(formmainData.getString("field0085"));//制单人名称
            djml.setCrerdate(timestampConvert(formmainData.getString("start_date"),"yyyyMMdd"));
            djml.setDjdate((timestampConvert(formmainData.getString("field0002"),"yyyyMMdd")));
            djml.setJe(formmainData.getString("field0017"));//金额
            djml.setJedx(formmainData.getString("field0018"));//金额大写
            djml.setGrdm(formmainData.getString("field0084"));//报销人代码
            djml.setGrmc(formmainData.getString("field0085"));//报销人名称
            djml.setBmdm(formmainData.getString("field0086"));//部门代码
            djml.setBmmc(formmainData.getString("field0087"));//部门名称
            djml.setXmdm(formmainData.getString("field0004"));//项目代码
            djml.setXmmc(formmainData.getString("field0005"));//项目名称
            djml.setZy(formmainData.getString("field0045"));//劳务内容
            djml.setWX00000051(formmainData.getString("field0006"));//讲座发生时间
            djml.setWX00000059(formmainData.getString("field0105"));//发放性质
            djml.setFzx7dm(formmainData.getString("field0104"));
            djml.setFzx7mc(formmainData.getString("field0103"));
            //报销明细
            List<OerDjnrEntity> djnrList = new ArrayList<>();
            //结算方式
            List<OerDjjsfsEntity> jsfsList = new ArrayList<>();
            //预算指标
            List<OerYszbEntity> yszbList = new ArrayList<>();

            if (CollectionUtils.isNotEmpty(forsonData)){
                int xh = 1;
                switch (fflx){
                    case "0"://校内职工/学生
                    case "3":
                        forson0044(headers, formmainData, djlxid, djml, forsonData, djnrList, jsfsList, yszbList, xh);
                        break;//校外一次性劳务
                    case "1":
                        forson0045(headers, formmainData, djlxid, djml, forsonData, djnrList, jsfsList, yszbList, xh);
                        break;
                    case "2"://通过第三方发放校外劳务
                        forson0046(headers, formmainData, djlxid, djml, forsonData, djnrList, jsfsList, yszbList, xh);
                        break;
                }
                logger.info("劳务费主表:{}",JSONObject.toJSONString(djml));
                logger.info("劳务费明细表:{}",JSONObject.toJSONString(djnrList));
                logger.info("劳务费结算方式:{}",JSONObject.toJSONString(jsfsList));
                logger.info("劳务费预算指标:{}",JSONObject.toJSONString(yszbList));
                djml.setOerDjnrEntityList(djnrList);
                djml.setOerDjjsfsEntityList(jsfsList);
                djml.setOerYszbEntityList(yszbList);
            }
        }else if (ColEventTypeEnum.ONSTOP.getType().equals(eventType)){
            //流程终止 修改状态，释放指标
            djml.setZt("0");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONCANCEL.getType().equals(eventType)){
            //流程撤销 修改状态，释放指标
            djml.setZt("1");
            djml.setCurshjd("0");
            djml.setNextshjd("-9");
            djml.setSsrid(null);
            djml.setSsr(null);
            djml.setSsrq(null);
            djml.setShrId(null);
            djml.setShrq(null);
        }else if (ColEventTypeEnum.ONPROCESSFINISHED.getType().equals(eventType)){
            //流程结束事件
            djml.setZt("3");
            djml.setCurshjd("999");
            djml.setNextshjd("-1");
            //查询协同附件
            List<FileInfoDTO> fileInfoList = fileDownloadV1(summaryId, fileApiCode);
            djml.setFileInfoList(fileInfoList);
        }
        String djmlStr = JSONObject.toJSONString(djml);
        logger.info("劳务费报文：{}",djmlStr);
        return djmlStr;
    }

    //校内职工/学生
    private static void forson0044(Map<String, String> headers, JSONObject formmainData, String djlxid, OerDjmlEntity djml, JSONArray forsonData, List<OerDjnrEntity> djnrList, List<OerDjjsfsEntity> jsfsList, List<OerYszbEntity> yszbList, int xh) {
        for (int i = 0; i< forsonData.size(); i++){
            JSONObject forson = forsonData.getJSONObject(i);
            String gsdm = djml.getGsdm();
            String kjnd = djml.getKjnd();
            String je = forson.getString("field0053");
            //单据内容
            OerDjnrEntity djnr = new OerDjnrEntity();
            djnr.setXh(String.valueOf(xh));
            djnr.setGsdm(gsdm);
            djnr.setKjnd(kjnd);
            djnr.setDjlxId(djlxid);
            djnr.setBnxId(headers.get("bxmx_bnxid"));
            djnr.setJe(je);
            djnr.setBmdm(null);//grp制单也没有这几个字段
            djnr.setBmmc(null);
            djnr.setXmdm(null);
            djnr.setXmmc(null);
            //指标id
            djnr.setZbId(formmainData.getString("field0029"));
            djnr.setZy(djml.getZy());
            djnr.setFjs(djml.getFjs());
            //支出项目
            djnr.setFzx6dm(formmainData.getString("field0089"));
            djnr.setFzx6mc(formmainData.getString("field0090"));
            //资金来源
            djnr.setFzx7dm(null);//grp制单也没这个
            djnr.setFzx7mc(null);
            //自定义项
            djnr.setYs00000051(forson.getString("field0052"));//发放明目
            djnr.setYs00000052("");//发放事项
            djnr.setYs00000053("");//打款时备注 oa没有
            djnr.setYs00000054("");//已开票应付劳务
            djnr.setYs00000055("");//扣补个税
            djnr.setYs00000056("");//个人所得税
            djnr.setYs00000057(forson.getString("field0053"));//实发金额
            djnr.setYs00000058("");//数量（课时）
            djnr.setYs00000059("");//标准
            djnrList.add(djnr);
            //结算方式
            OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
            jsfs.setGsdm(gsdm);
            jsfs.setKjnd(kjnd);
            jsfs.setDjlxId(djlxid);
            jsfs.setBnxid(headers.get("jsfs_bnxid"));
            jsfs.setXh(String.valueOf(xh));
            jsfs.setJsfsdm(formmainData.getString("field0107"));
            jsfs.setJsfsmc(formmainData.getString("field0106"));
            jsfs.setKmdm(forson.getString(""));
            jsfs.setKmmc(forson.getString(""));
            jsfs.setSkr(forson.getString("field0049"));
            jsfs.setKhyh(forson.getString("field0051"));
            jsfs.setYhzh(forson.getString("field0050"));
            jsfs.setJe(je);
            jsfs.setYh("");//银行类型 例如 招商银行
            jsfs.setYhhh("");// 联行号
            jsfs.setProvince("");//省
            jsfs.setCity("");//市
            //支付方式为个人、公务卡时 可以选择 经办人、负责人、其他
            jsfs.setRytype("");//人员类型
            //用途
            jsfs.setYt(forson.getString(""));
            jsfsList.add(jsfs);

            //预算指标
            OerYszbEntity yszb = new OerYszbEntity();
            BeanUtil.copyProperties(djnr,yszb);
            yszb.setBnxId(headers.get("yszb_bnxid"));
            yszb.setZbdm(formmainData.getString("field0029"));
            yszb.setZy(djnr.getZy());
            yszb.setKmdm(forson.getString(""));
            yszb.setKmmc(forson.getString(""));
            yszb.setXh(String.valueOf(xh));
            yszbList.add(yszb);
            xh++;
        }
    }

    //校外一次性劳务
    private static void forson0045(Map<String, String> headers, JSONObject formmainData, String djlxid, OerDjmlEntity djml, JSONArray forsonData, List<OerDjnrEntity> djnrList, List<OerDjjsfsEntity> jsfsList, List<OerYszbEntity> yszbList, int xh) {
        for (int i = 0; i< forsonData.size(); i++){
            JSONObject forson = forsonData.getJSONObject(i);
            String gsdm = djml.getGsdm();
            String kjnd = djml.getKjnd();
            String je = forson.getString("field0062");
            //单据内容
            OerDjnrEntity djnr = new OerDjnrEntity();
            djnr.setXh(String.valueOf(xh));
            djnr.setGsdm(gsdm);
            djnr.setKjnd(kjnd);
            djnr.setDjlxId(djlxid);
            djnr.setBnxId(headers.get("bxmx_bnxid"));
            djnr.setJe(je);
            djnr.setBmdm(null);//grp制单也没有这几个字段
            djnr.setBmmc(null);
            djnr.setXmdm(null);
            djnr.setXmmc(null);
            //指标id
            djnr.setZbId(formmainData.getString("field0029"));
            djnr.setZy(djml.getZy());
            djnr.setFjs(djml.getFjs());
            //支出项目
            djnr.setFzx6dm(formmainData.getString("field0089"));
            djnr.setFzx6mc(formmainData.getString("field0090"));
            //资金来源
            djnr.setFzx7dm(null);//grp制单也没这个
            djnr.setFzx7mc(null);
            //自定义项
            djnr.setYs00000051("");//发放明目
            djnr.setYs00000052("");//发放事项
            djnr.setYs00000053("");//打款时备注 oa没有
            djnr.setYs00000054(forson.getString("field0062"));//已开票应付劳务
            djnr.setYs00000055(forson.getString("field0063"));//扣补个税
            djnr.setYs00000056(forson.getString("field0064"));//个人所得税
            djnr.setYs00000057(forson.getString("field0062"));//实发金额
            djnr.setYs00000058("");//数量（课时）
            djnr.setYs00000059("");//标准
            djnrList.add(djnr);
            //结算方式
            OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
            jsfs.setGsdm(gsdm);
            jsfs.setKjnd(kjnd);
            jsfs.setDjlxId(djlxid);
            jsfs.setBnxid(headers.get("jsfs_bnxid"));
            jsfs.setXh(String.valueOf(xh));
            jsfs.setJsfsdm(formmainData.getString("field0107"));
            jsfs.setJsfsmc(formmainData.getString("field0106"));
            jsfs.setKmdm(forson.getString(""));
            jsfs.setKmmc(forson.getString(""));
            jsfs.setSkr(forson.getString("field0058"));
            jsfs.setKhyh(forson.getString("field0059"));
            jsfs.setYhzh(forson.getString("field0060"));
            jsfs.setJe(je);
            jsfs.setYh("");//银行类型 例如 招商银行
            jsfs.setYhhh("");// 联行号
            jsfs.setProvince("");//省
            jsfs.setCity("");//市
            //支付方式为个人、公务卡时 可以选择 经办人、负责人、其他
            jsfs.setRytype("");//人员类型
            //用途
            jsfs.setYt(forson.getString(""));
            jsfsList.add(jsfs);

            //预算指标
            OerYszbEntity yszb = new OerYszbEntity();
            BeanUtil.copyProperties(djnr,yszb);
            yszb.setBnxId(headers.get("yszb_bnxid"));
            yszb.setZbdm(formmainData.getString("field0029"));
            yszb.setZy(djnr.getZy());
            yszb.setKmdm(forson.getString(""));
            yszb.setKmmc(forson.getString(""));
            yszb.setXh(String.valueOf(xh));
            yszbList.add(yszb);
            xh++;
        }
    }

    //通过第三方发放校外劳务
    private static void forson0046(Map<String, String> headers, JSONObject formmainData, String djlxid, OerDjmlEntity djml, JSONArray forsonData, List<OerDjnrEntity> djnrList, List<OerDjjsfsEntity> jsfsList, List<OerYszbEntity> yszbList, int xh) {
        for (int i = 0; i< forsonData.size(); i++){
            JSONObject forson = forsonData.getJSONObject(i);
            String gsdm = djml.getGsdm();
            String kjnd = djml.getKjnd();
            String je = forson.getString("field0079");
            //单据内容
            OerDjnrEntity djnr = new OerDjnrEntity();
            djnr.setXh(String.valueOf(xh));
            djnr.setGsdm(gsdm);
            djnr.setKjnd(kjnd);
            djnr.setDjlxId(djlxid);
            djnr.setBnxId(headers.get("bxmx_bnxid"));
            djnr.setJe(je);
            djnr.setBmdm(null);//grp制单也没有这几个字段
            djnr.setBmmc(null);
            djnr.setXmdm(null);
            djnr.setXmmc(null);
            //指标id
            djnr.setZbId(formmainData.getString("field0029"));
            djnr.setZy(djml.getZy());
            djnr.setFjs(djml.getFjs());
            //支出项目
            djnr.setFzx6dm(formmainData.getString("field0089"));
            djnr.setFzx6mc(formmainData.getString("field0090"));
            //资金来源
            djnr.setFzx7dm(null);//grp制单也没这个
            djnr.setFzx7mc(null);
            //自定义项
            djnr.setYs00000051("");//发放明目
            djnr.setYs00000052(forson.getString("field0076"));//发放事项
            djnr.setYs00000053("");//打款时备注 oa没有
            djnr.setYs00000054("");//已开票应付劳务
            djnr.setYs00000055("");//扣补个税
            djnr.setYs00000056("");//个人所得税
            djnr.setYs00000057("");//实发金额
            djnr.setYs00000058(forson.getString("field0077"));//数量（课时）
            djnr.setYs00000059(forson.getString("field0078"));//标准
            djnrList.add(djnr);
            //结算方式
            OerDjjsfsEntity jsfs = new OerDjjsfsEntity();
            jsfs.setGsdm(gsdm);
            jsfs.setKjnd(kjnd);
            jsfs.setDjlxId(djlxid);
            jsfs.setBnxid(headers.get("jsfs_bnxid"));
            jsfs.setXh(String.valueOf(xh));
            jsfs.setJsfsdm(formmainData.getString("field0107"));
            jsfs.setJsfsmc(formmainData.getString("field0106"));
            jsfs.setKmdm(forson.getString(""));
            jsfs.setKmmc(forson.getString(""));
            jsfs.setSkr(forson.getString("field0071"));
            jsfs.setKhyh(forson.getString("field0072"));
            jsfs.setYhzh(forson.getString("field0073"));
            jsfs.setJe(je);
            jsfs.setYh("");//银行类型 例如 招商银行
            jsfs.setYhhh("");// 联行号
            jsfs.setProvince("");//省
            jsfs.setCity("");//市
            //支付方式为个人、公务卡时 可以选择 经办人、负责人、其他
            jsfs.setRytype("");//人员类型
            //用途
            jsfs.setYt(forson.getString(""));
            jsfsList.add(jsfs);

            //预算指标
            OerYszbEntity yszb = new OerYszbEntity();
            BeanUtil.copyProperties(djnr,yszb);
            yszb.setBnxId(headers.get("yszb_bnxid"));
            yszb.setZbdm(formmainData.getString("field0029"));
            yszb.setZy(djnr.getZy());
            yszb.setKmdm(forson.getString(""));
            yszb.setKmmc(forson.getString(""));
            yszb.setXh(String.valueOf(xh));
            yszbList.add(yszb);
            xh++;
        }
    }
    /**
     * 时间戳转成  指定格式
     * @param timestamp 时间戳
     * @param format 格式
     * @return
     */
    private String timestampConvert(String timestamp,String format){
        if (StrUtil.isNotEmpty(timestamp)){
            if (NumberUtil.isNumber(timestamp)){
                try {
                    DateTime date = DateUtil.date(Long.valueOf(timestamp));
                    String formattedDate = DateUtil.format(date, format);
                    return formattedDate;
                }catch (Exception e){
                    logger.error("日期转换出错:{}",e);
                }
            }else if (timestamp.contains("-")){
                Date date = DateUtil.parse(timestamp);
                String formatDate = DateUtil.format(date, format);
                return formatDate;
            }
        }
        return timestamp;
    }
    //这个方法暂时没用
    public List<FileInfoDTO> fileDownloadDiscard(String summaryId, String apiCode) {
        try {
            List<GrpU8CollAttachmentResDTO> colAttachmentList = restUtil.getColAttachments(summaryId, "0", apiCode, null);
            // 下载协同附件
            if (CollectionUtils.isNotEmpty(colAttachmentList)) {
                String token = restUtil.getToken(null, apiCode);
                List<FileInfoDTO> fileList = new ArrayList<>();
                String today = DateUtil.today();
                String zipPath = DSK + File.separator + today + File.separator + "attachments.zip";

                // 确保目录存在
                if (!FileUtil.isDirectory(DSK + File.separator + today)) {
                    FileUtil.mkdir(DSK + File.separator + today);
                }

                // 创建 ZipOutputStream
                try (ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zipPath), Charset.forName("GBK"))) {
                    for (GrpU8CollAttachmentResDTO att : colAttachmentList) {
                        FileInfoDTO fileInfoDTO = new FileInfoDTO();

                        String fileName = URLDecoder.decode(att.getFilename(), "UTF-8");
                        String fileUrl = att.getFileUrl();
                        byte[] bytes = restUtil.downloadFileBytes(null, apiCode, att.getFileUrl(), fileName, token);
                        String filePath = DSK + File.separator + today + File.separator + att.getFileUrl() + "." + att.getExtension();
                        File file = new File(filePath);

                        // 使用 FileOutputStream 写入字节数组到文件
                        try (FileOutputStream fos = new FileOutputStream(file)) {
                            fos.write(bytes);
                        }

                        if (null != file) {
                            // 将文件添加到压缩包
                            writeZipFile(file, zos, fileName, fileUrl);

                            // 读取压缩文件的字节数组
                            File zipFile = new File(zipPath);
                            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream((int) zipFile.length());
                            try (BufferedInputStream bufferedInputStream = new BufferedInputStream(new FileInputStream(zipFile))) {
                                int buf_size = 1024;
                                byte[] buffer = new byte[buf_size];
                                int len;
                                while (-1 != (len = bufferedInputStream.read(buffer, 0, buf_size))) {
                                    byteArrayOutputStream.write(buffer, 0, len);
                                }
                                byte[] fileByte = byteArrayOutputStream.toByteArray();
                                fileInfoDTO.setData(fileByte);
                                fileInfoDTO.setFile_size(att.getSize());
                                fileInfoDTO.setFile_name(fileName);
                                fileList.add(fileInfoDTO);
                                logger.info("压缩后的文件读取字节数组完成");
                            } catch (Exception e) {
                                logger.error("压缩附件&读取字节数组出错:{}", e);
                            }
                        }
                    }
                    logger.info("压缩文件1111111");
                    return fileList;
                } catch (Exception ex) {
                    logger.error("压缩附件添加到fileList出错：{}", ex);
                }
            }
        } catch (Exception e) {
            logger.error("下载附件出错:{}", e);
        }
        return null;
    }

    //从OA下载附件
    public List<FileInfoDTO> fileDownloadV1(String summaryId, String apiCode) {
        Assert.notEmpty(summaryId,"summaryId不能为空");
        Assert.notEmpty(apiCode,"apiCode不能为空");
        try {
            //1、查询协同附件
            List<GrpU8CollAttachmentResDTO> colAttachmentList = restUtil.getColAttachments(summaryId, "0", apiCode, null);
            //2、下载协同附件
            if (CollectionUtils.isNotEmpty(colAttachmentList)){
                //获取OA token
                String token = restUtil.getToken(null, apiCode);
                List<FileInfoDTO> fileList = new ArrayList<>();
                String today = DateUtil.today();
                String basePath = DSK + File.separator + today + File.separator;
                // 确保目录存在
                if (!FileUtil.isDirectory(basePath)) {
                    FileUtil.mkdir(basePath);
                }
                for (GrpU8CollAttachmentResDTO att : colAttachmentList) {
                    String fileName = URLDecoder.decode(att.getFilename(), "UTF-8");
                    String fileUrl = att.getFileUrl();
                    byte[] bytes = restUtil.downloadFileBytes(null, apiCode, att.getFileUrl(), fileName, token);
                    String filePath = basePath + att.getFileUrl() + "." + att.getExtension();
                    File file = new File(filePath);
                    // 使用 FileOutputStream 写入字节数组到文件
                    try (FileOutputStream fos = new FileOutputStream(file)) {
                        fos.write(bytes);
                    }
                    //3、把协同附件压缩成.zip
                    if (null != file){
                        String zipPath = basePath + att.getFileUrl() + ".zip";
                        ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zipPath), Charset.forName("GBK"));
                        writeZipFile(file, zos, fileName,fileUrl);
                        zos.close();
                        //4、返回.zip附件路径
                        FileInfoDTO fileInfo = new FileInfoDTO();
                        fileInfo.setZip_file_path(zipPath);
                        fileInfo.setOriginal_file_path(filePath);
                        fileInfo.setFile_name(fileName);
                        fileInfo.setFile_size(att.getSize());
                        fileList.add(fileInfo);
                    }
                }
                return fileList;
            }
        }catch(Exception e){
            logger.error("下载OA附件出错:{}",e);
        }
        return null;
    }
    /**
     * 把文件压缩成zip
     * @param file 要压缩的文件
     * @param zos 文件压缩流
     * @param fileName 文件名
     * @param fileUrl 文件id
     */
    private void writeZipFile(File file, ZipOutputStream zos, String fileName, String fileUrl) {
        if (null != file && null != zos) {
            try (FileInputStream fos = new FileInputStream(file);
                 BufferedInputStream bis = new BufferedInputStream(fos)) {
                logger.info("=====压缩文件=====");
                zos.putNextEntry(new ZipEntry(fileName ));
                int len;
                byte[] buf = new byte[1024];
                while ((len = bis.read(buf, 0, 1024)) != -1) {
                    zos.write(buf, 0, len);
                }
                logger.info("=====压缩完成=====");
            } catch (Exception e) {
                e.printStackTrace();
                logger.error("=====压缩文件出错=====:{}", e);
            }
        }
    }




    public enum DjlxEnum {
        TRAVEL("travel","差旅报销单"),
        EXPENSE("expense","费用报销单"),
        HXKY("hxky","横向科研"),
        ZXKY("zxky","纵向科研"),
        LABOR("labor","劳务费报销单"),
        ;

        private String type;
        private String name;

        public String getType() {
            return type;
        }

        public void setType(String type) {
            this.type = type;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        DjlxEnum(String type, String name) {
            this.type = type;
            this.name = name;
        }
    }

    public static void main(String[] args) {
        BigDecimal gzf = Convert.toBigDecimal("12.11", BigDecimal.ZERO);
        System.out.println(gzf);
        BigDecimal jtbz = Convert.toBigDecimal("1", BigDecimal.ZERO);
        System.out.println(jtbz);
        System.out.println(gzf.add(jtbz));
    }
}
